import { __awaiter, __generator } from "tslib";
import { jsx as _jsx } from "react/jsx-runtime";
/* eslint-disable react/no-deprecated */
import ReactDOM from 'react-dom';
import HTMLReactParser from 'html-react-parser/lib/index';
import { addHighlight, isHighlightable } from '../../libs/addHighlight';
import { deserializeRange, serializeRange } from '../../libs/serialize';
import { useCallback, useEffect } from 'react';
import { generateId } from '../../libs/uid';
import { getPopoverElement, getSpanElement } from '../../libs/wrapperElements';
import DefaultPopover from '../DeafultPopover';
import { useSelections } from '../../hooks/UseSelection';
var Highlighter = function (_a) {
    var htmlString = _a.htmlString, onClickHighlight = _a.onClickHighlight, disablePopover = _a.disablePopover, maxSelectionLength = _a.maxSelectionLength, minSelectionLength = _a.minSelectionLength, rootClassName = _a.rootClassName, PopoverChildren = _a.PopoverChildren, PopoverClassName = _a.PopoverClassName, highlightColor = _a.highlightColor, selectionWrapperClassName = _a.selectionWrapperClassName, onClick = _a.onClick;
    var _b = useSelections(), selections = _b.selections, addSelection = _b.addSelection, removeSelection = _b.removeSelection;
    var getWrapper = useCallback(function (selection) {
        var span = getSpanElement({ className: selectionWrapperClassName, highlightColor: highlightColor });
        if (!disablePopover) {
            var popover_1 = getPopoverElement({ className: PopoverClassName });
            span.addEventListener('mouseover', function () {
                popover_1.style.visibility = 'visible';
                popover_1.style.opacity = '1';
            });
            span.addEventListener('mouseout', function () {
                popover_1.style.visibility = 'hidden';
                popover_1.style.opacity = '0';
            });
            span.id = selection.id;
            popover_1.id = "pop-".concat(selection.id);
            span.appendChild(popover_1);
            span.onclick = function () {
                if (onClickHighlight) {
                    onClickHighlight(selection);
                }
            };
            if (PopoverChildren) {
                ReactDOM.render(_jsx(PopoverChildren, { selection: selection, removeSelection: removeSelection }), popover_1);
            }
            else {
                ReactDOM.render(_jsx(DefaultPopover, { removeSelection: removeSelection, selection: selection }), popover_1);
            }
        }
        return span;
    }, [
        selectionWrapperClassName,
        PopoverClassName,
        disablePopover,
        highlightColor,
        onClickHighlight,
        PopoverChildren,
        removeSelection,
    ]);
    var handleMouseUp = function () {
        var selection = window.getSelection();
        if (!selection)
            return;
        if (minSelectionLength && selection.toString().length < minSelectionLength)
            return;
        if (maxSelectionLength && selection.toString().length > maxSelectionLength)
            return;
        var range = selection.getRangeAt(0);
        if (!isHighlightable(range))
            return;
        var newSelection = { meta: serializeRange(range), text: range.toString(), id: generateId() };
        addSelection(newSelection);
        // addHighlight(range,getWrapper(newSelection))
    };
    useEffect(function () {
        if (selections && selections.length) {
            selections.forEach(function (item) { return __awaiter(void 0, void 0, void 0, function () {
                var range;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, deserializeRange(item.meta)];
                        case 1:
                            range = _a.sent();
                            if (range) {
                                addHighlight(range, getWrapper(item));
                            }
                            return [2 /*return*/];
                    }
                });
            }); });
        }
    }, [selections, getWrapper]);
    return (_jsx("div", { onClick: onClick, onMouseUp: handleMouseUp, className: rootClassName, children: HTMLReactParser(htmlString) }));
};
export default Highlighter;
//# sourceMappingURL=Highlighter.js.map