import React, { useState } from "react";
var SmartRating = function (props) {
    var stars = Array.from({ length: 5 }, function (_, i) { return i + 1; });
    var _a = useState(0), rating = _a[0], setRating = _a[1];
    return (React.createElement("div", { className: "star-rating rating-".concat(props.theme) },
        React.createElement("h1", null, props.title),
        stars.map(function (star, index) {
            var starCss = star <= rating ? "starActive" : "starInactive";
            return (React.createElement("button", { disabled: props.disabled, "data-testid": "".concat(props.testIdPrefix, "-").concat(index), key: star, className: "".concat(starCss), onClick: function () { return setRating(star); } },
                React.createElement("span", { className: "star" }, "\u2605")));
        })));
};
export default SmartRating;
//# sourceMappingURL=SmartRating.js.map